<template>
  <div
    class="relative flex-auto min-w-max md:max-w-0"
    :class="$attrs['class']"
    ref="container"
  >
    <label for="location-input" class="sr-only">{{
      $gettext('Location')
    }}</label>
    <div
      class="flex absolute inset-y-0 left-0 items-center pl-3 pointer-events-none"
    >
      <svg
        aria-hidden="true"
        width="24"
        height="24"
        stroke-width="1.5"
        viewBox="0 0 24 24"
        fill="none"
        xmlns="http://www.w3.org/2000/svg"
      >
        <path
          d="M20 10C20 14.4183 12 22 12 22C12 22 4 14.4183 4 10C4 5.58172 7.58172 2 12 2C16.4183 2 20 5.58172 20 10Z"
          stroke="currentColor"
          stroke-width="1.5"
        />
        <path
          d="M12 11C12.5523 11 13 10.5523 13 10C13 9.44772 12.5523 9 12 9C11.4477 9 11 9.44772 11 10C11 10.5523 11.4477 11 12 11Z"
          fill="currentColor"
          stroke="currentColor"
          stroke-linecap="round"
          stroke-linejoin="round"
        />
      </svg>
    </div>
    <input
      ref="input"
      class="bg-gray-50 text-gray-900 border border-gray-300 text-sm rounded-lg block w-full pl-10 p-2.5 dark:bg-gray-700 dark:placeholder-gray-400 dark:text-white"
      :value="modelValue"
      v-bind="inputProps"
      @input="handleInput($event.target.value)"
      @keydown.enter="handleEnter"
      @keydown.esc="handleEsc"
      @keydown.tab="handleTab"
      @keydown.up.prevent="handleUp"
      @keydown.down.prevent="handleDown"
      @focus="handleFocus"
      @blur="handleBlur"
      id="location-input"
    />
    <span
      class="absolute right-0 pr-3 flex items-center inset-y-0 text-vxvue-700"
    >
      <svg
        class="animate-spin w-5 h-5"
        xmlns="http://www.w3.org/2000/svg"
        fill="none"
        viewBox="0 0 24 24"
        v-if="loading"
      >
        <circle
          class="opacity-25"
          cx="12"
          cy="12"
          r="10"
          stroke="currentColor"
          stroke-width="4"
        ></circle>
        <path
          class="opacity-75"
          fill="currentColor"
          d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"
        ></path>
      </svg>
    </span>
    <ul
      v-if="results.length"
      ref="resultList"
      class="z-[500]"
      v-bind="listProps"
      @click="handleResultClick"
      @mousedown.prevent
    >
      <template v-for="(result, index) in results">
        <slot name="result" :result="result" :props="itemProps[index]">
          <li :key="itemProps[index].id" v-bind="itemProps[index]">
            {{ getResultValue(result) }}
          </li>
        </slot>
      </template>
    </ul>
  </div>
</template>

<script lang="ts">
  import { defineComponent } from 'vue'
  import { debounce } from 'lodash'
  const uniqueId = (() => {
    let counter = 0
    return (prefix) => (prefix || '') + ++counter
  })()

  export default defineComponent({
    name: 'autocomplete',
    inheritAttrs: false,

    emits: ['update:modelValue', 'blur', 'submit'],
    props: {
      modelValue: {
        type: String,
        default: '',
      },
      search: {
        type: Function,
        required: true,
      },
      autoSelect: {
        type: Boolean,
        default: false,
      },
      getResultValue: {
        type: Function,
        default: (result) => result,
      },
    },

    data() {
      return {
        resultListId: uniqueId((this.$attrs.id || 'autocomplete') + '-'),
        results: [],
        selectedIndex: -1,
        searchCounter: 0,
        expanded: false,
        loading: false,
        position: 'top-0 translate-y-12',
        resetPosition: true,
      }
    },

    computed: {
      inputProps() {
        return {
          role: 'combobox',
          autocomplete: 'off',
          autocapitalize: 'off',
          autocorrect: 'off',
          spellcheck: 'false',
          'aria-autocomplete': 'list',
          'aria-haspopup': 'listbox',
          'aria-owns': this.resultListId,
          'aria-expanded': this.expanded ? 'true' : 'false',
          'aria-activedescendant':
            this.selectedIndex > -1
              ? this.itemProps[this.selectedIndex].id
              : '',
          ...this.$attrs,
        }
      },
      listProps() {
        return {
          id: this.resultListId,
          class: [
            'absolute min-w-full transform z-10 rounded shadow-md bg-white dark:bg-zinc-700 max-h-96 overflow-auto text-left',
            this.position,
          ],
          role: 'listbox',
        }
      },
      itemProps() {
        return this.results.map((result, index) => ({
          id: (this.$attrs.id || 'autocomplete') + '-item-' + index,
          class: [
            'py-2 px-4 cursor-pointer hover:bg-gray-200 hover:dark:bg-zinc-500',
            this.selectedIndex === index ? 'bg-gray-200 dark:bg-zinc-500' : '',
          ],
          'data-result-index': index,
          role: 'option',
          ...(this.selectedIndex === index ? { 'aria-selected': 'true' } : {}),
        }))
      },
    },

    mounted() {
      document.body.addEventListener('click', this.handleDocumentClick)
    },

    beforeUnmount() {
      document.body.removeEventListener('click', this.handleDocumentClick)
    },

    updated() {
      if (!this.$refs.resultList) {
        return
      }

      const inputPos = this.$refs.input.getBoundingClientRect()
      const listPos = this.$refs.resultList.getBoundingClientRect()

      if (this.resetPosition && this.results.length) {
        this.resetPosition = false

        // show list above or below

        this.position =
          inputPos.bottom + listPos.height > window.innerHeight &&
          window.innerHeight - inputPos.bottom < inputPos.top &&
          window.scrollY + inputPos.top - listPos.height > 0
            ? 'bottom-0  -translate-y-12'
            : 'top-0 translate-y-12'
      }

      // Make sure selected result isn't scrolled out of view

      const selectedElem = this.$refs.resultList.querySelector(
        '[data-result-index="' + this.selectedIndex + '"]'
      )

      if (selectedElem) {
        const selectedPos = selectedElem.getBoundingClientRect()

        if (selectedPos.top < listPos.top) {
          // Element is above viewable area
          this.$refs.resultList.scrollTop -= listPos.top - selectedPos.top
        } else if (selectedPos.bottom > listPos.bottom) {
          // Element is below viewable area
          this.$refs.resultList.scrollTop += selectedPos.bottom - listPos.bottom
        }
      }
    },

    methods: {
      handleInput: debounce(function (value) {
        this.doHandleInput(value)
      }, 250),
      doHandleInput(value) {
        this.$emit('update:modelValue', value)
        this.updateResults(value)
      },

      handleFocus(event) {
        this.updateResults(event.target.value)
      },

      handleBlur() {
        this.hideResults()
        this.$emit('blur')
      },

      handleUp() {
        const listLen = this.results.length
        this.selectedIndex =
          (((this.selectedIndex - 1) % listLen) + listLen) % listLen
      },

      handleDown(event) {
        if (!this.expanded) {
          this.handleFocus(event)
        }
        const listLen = this.results.length
        this.selectedIndex =
          (((this.selectedIndex + 1) % listLen) + listLen) % listLen
      },

      handleEsc() {
        this.hideResults()
        this.$emit('update:modelValue', '')
      },

      handleEnter() {
        this.submit()
      },

      handleTab() {
        this.selectResult()
      },

      hideResults() {
        this.selectedIndex = -1
        this.results = []
        this.expanded = false
        this.resetPosition = true
      },

      selectResult() {
        let selectedResult = this.results[this.selectedIndex]
        if (selectedResult) {
          this.$emit('update:modelValue', this.getResultValue(selectedResult))
        } else {
          selectedResult = {
            location: { lat: undefined, lon: undefined },
            name: undefined,
          }
        }
        this.hideResults()
        return selectedResult
      },

      handleResultClick(event) {
        const result = event.target.closest('[data-result-index]')
        if (result) {
          this.selectedIndex = parseInt(result.dataset.resultIndex, 10)
          this.submit()
        }
      },
      submit() {
        this.$emit('submit', this.selectResult())
      },

      handleDocumentClick(event) {
        if (this.$refs.container.contains(event.target)) {
          return
        }
        this.hideResults()
      },

      updateResults(value) {
        const search = this.search(value)

        if (search instanceof Promise) {
          const currentSearch = ++this.searchCounter
          this.loading = true

          search.then((results) => {
            if (currentSearch !== this.searchCounter) {
              return
            }
            this.results = results
            this.loading = false

            if (!this.results?.length) {
              this.hideResults()
            } else {
              this.selectedIndex = this.autoSelect ? 0 : -1
              this.expanded = true
            }
          })
        } else {
          this.results = search

          if (this.results.length === 0) {
            this.hideResults()
          } else {
            this.selectedIndex = this.autoSelect ? 0 : -1
            this.expanded = true
          }
        }
      },
    },
  })
</script>
